-- Часть 1.


-- *** *** *** *** *** --
--       Локации       --
-- *** *** *** *** *** --

townDoor = room {
	nam = 'у входа';
	pic = 'img/town_door.png';
	dsc = 'Видимо, это вход в здание.';
	way = { 'townCrossroads' };
	obj = {
		'bench',		-- лавочка.
		'urn',			-- урна.
		'townDoorObj',	-- входная дверь.
		'postBox'		-- почтовый ящик.
	};
};

townCrossroads = room {
	nam = 'перекрёсток';
	pic = 'img/town_crossroads.png';
	dsc = 'Я не могу отделаться от мысли, что за мной кто-то наблюдает. Хотя вокруг ни души.';
	way = { 'townLamp', 'townDoor' };
};

townLamp = room {
	nam = 'под фонарём';
	pic = 'img/town_lamp.png';
	dsc = 'Один из спальных районов этого сумрачного города.';
	way = { 'townCrossroads' };
	obj = {
		'townLampObj',	-- фонарь.
		'boxes',		-- ящики.
		'suitcase'		-- чемодан.
	};
};

myRoom = room {
	nam = 'моя палата';
	pic = 'img/my_room.png';
	dsc = 'Я нахожусь в больничной палате. Комната окутана полумраком.';
	exit = function(s, t)
		if have( chair ) then
			p 'Я поставил стул на место.';
			drop( chair );
		end;
		if t == corridor and roomDoor.status then
			p 'Я вышел в коридор.';
		elseif t == inSmallDoor then
			return true;
		elseif t == showVision1 then
			return true;
		else
			p 'Дверь закрыта.';
			return false;
		end;
	end;
	way = { vroom('выйти в коридор', 'corridor')};
	obj = { 'paintOnTheWall',	-- краска на стене.
			'smallDoor',		-- небольшая дверка.
			'ironBed',			-- железная кровать.
			'smallWindow',		-- маленькое окошко.
			'shardBrick',		-- осколок кирпича.
			'chair',			-- стул.
			'chairRuins',		-- обломки стула.
			'roomDoor'};		-- дверь.
};

inSmallDoor = room {
	nam = 'в дверном проёме';
	pic = 'img/in_door_no_man.png';
	entered = 'Я попытался протиснуться в дверной проём, но он был настолько тесным, что даже голова пролезала с большим трудом.';
	exit = 'Я вылез обратно.';
	dsc = 'Похоже, что соседняя палата точно такая же, как и моя. Такая же железная кровать, такое же крошечное окошко, тот же полумрак.';
	way = { vroom('вылезти обратно', 'myRoom')};
	obj = { 'unknownMan',		-- человек.
			'clawHammer',		-- молоток.
			'keys'};			-- связка ключей.
};

secondRoom = room {
	nam = 'соседняя палата';
	pic = 'img/second_room.png';
	dsc = 'Похоже, что соседняя палата точно такая же, как и моя. Такая же железная кровать, такое же крошечное окошко, тот же полумрак.';
	obj = { 'dips',				-- фишки.
			'picture'};			-- рисунок на стене.
	way = { vroom('выйти в коридор', 'corridor')};
};

corridor = room {
	nam = 'коридор';
	pic = 'img/corridor.png';
	dsc = 'В коридоре очень темно. Здесь расположена моя палата. Рядом ещё одна. Чуть дальше -- лаборатория. Ни начала, ни конца коридора не видно.';
	exit = function(s, t)
		-- Если пытаемся зайти из коридора в соседнюю палату...
		if t == secondRoom then
			-- Если не показывали видение 2 - показываем.
			if not showVision2.status then
				walk('showVision2');
				return false;
			end;
			-- Если дверь закрыта - выводим сообщение.
			if not roomDoor2.status then
				p 'Дверь закрыта.';
				return false;
			end;
			-- Если дверь открыта - заходим.
			return true;
		end;
		-- Если пытаемся зайти из коридора в свою палату, загадка с доской решена и ключа на цепочке с собой нет - показываем видение 5.
		if t == myRoom and not have( keyOnCircuit ) and
			playGameDlg.newG[1] == '+' and
			playGameDlg.newG[2] == '+' and
			playGameDlg.newG[3] == '+' and
			playGameDlg.newG[4] == '+' then
				walk('showVision5');
		end;
	end;
	way = { 'myRoom', 'secondRoom', 'lab' };
	obj = { 'roomDoor2'};		-- дверь соседней палаты.
};

lab = room {
	nam = 'лаборатория';
	pic = 'img/lab_no_man.png';
	dsc = 'Кучи пробирок с неизвестными веществами, пара столов и идеальная чистота.';
	way = { vroom('выйти в коридор', 'corridor')};
	obj = {'mouseBox',			-- клетка с белыми мышами.
			'twinMan',			-- человек в белом халате.
			'board'};			-- игровая доска.
};