-- Часть 1.


-- *** *** *** *** *** --
--       Объекты       --
-- *** *** *** *** *** --

townDoorObj = obj {
	nam = 'дверь';
	var {
		status = false;		-- Дверб открыта/закрыта. true/false.
	};
	act = function(s)
		if s.status then
			walk( 'showVision6' );
		else
			p 'Дверь закрыта.';
		end;
	end;
	dsc = 'Белая {дверь} закрывает проход.';
};

postBox = obj {
	nam = 'почтовый ящик';
	dsc = 'На стене у двери висит {почтовый ящик}.';
	used = function (s, w)
		if w == paperText then
			if have( keyOnCircuit ) then
				p 'Я опустил клочок бумажки в почтовый ящик. Входная дверь со скрипом открылась.';
				remove( paperText, me());
				townDoorObj.status = true;
			else
				p 'Я опустил клочок бумажки в почтовый ящик, но ничего не произошло.';
				remove( paperText, me());
				if paperText.numbers == 1 then
					paperText.numbers = 2;
				else
					paperText.numbers = 1;
				end;
			end;
		end;
	end;
};

paperText = obj {
	nam = 'бумажка с цифрами';
	var {
		numbers = 1;	-- При =1 числа на бумажке:35. При =2 - числа:43.
	};
	inv = function()
		if have( keyOnCircuit ) then
			p 'Чистый лист бумаги.';
		else
			if paperText.numbers == 1 then
				p [[На бумажке нарисованы символы: 35]];
			else
				p [[На бумажке нарисованы символы: 43]];
			end;
		end;
	end;
};

urn = obj {
	nam = 'урна';
	act = function()
		if have( paperText ) then
			p 'Я не нашёл ничего интересного.';
		else
			p 'В урне лежал обрывок бумаги с цифрами. Кажется, где-то я уже его видел. Или тогда был другой?';
			take( paperText );
		end;
	end;
	dsc = 'Около лавочки расположена {урна}.';
};

bench = obj {
	nam = 'лавочка';
	act = 'Я посмотрел на лавочку. Чувство тревоги не покидало меня. Надо было что-то делать.';
	dsc = 'К стене прислонена деревянная {лавочка}.';
};

keyOnCircuit = obj {
	nam = 'ключ на цепочке';
};

townLampObj = obj {
	nam = 'фонарь';
	act = 'Похоже, что этот фонарь - единственный источник света в этом сумрачном царстве.';
	dsc = 'Рядом со мной расположен {фонарь}.';
};

suitcase = obj {
	nam = 'чемодан';
	act = function()
		walk( 'openingLockDlg' );
	end;
	dsc = 'Среди груды ящиков я вижу потрёпанный {чемодан}.';
}: disable();

boxes = obj {
	nam = 'ящики';
	act = function()
		p 'Старые, отслужившие своё, ящики. Среди них я вижу потрёпанный чемодан.';
		enable( 'suitcase' );
	end;
	dsc = 'Неподалёку лежат {ящики} и картонные коробки, сваленные в кучу.';
};

paintOnTheWall = obj {
	nam = 'краска';
	act = 'Трещинки от краски причудливым образом напоминают очертания бурного моря. И кажется, я даже вижу огромные волны.';
	dsc = 'На одной из стен от времени потрескалась {краска}.';
	used = function (s, w)
		if w == coin then
			p 'Монеткой я счистил облупившуюся краску со стены. Под краской скрывалась небольшая дверка. Видимо, в соседнюю палату.';
			disable( paintOnTheWall );
			enable( smallDoor );
		end;
	end;
};

ironBed = obj {
	nam = 'железная кровать';
	var {
		isFirst = true;			-- Первый раз нашли монетку? Да/Нет. true/false.
	};
	used = function (s, w)
		if w == chair then
			p 'Я поставил стул около кровати.';
			chair.dest = 'кровать';
			drop( chair );
		end;
	end;
	act = function(s)
		if not have(coin) then
			if s.isFirst then
				p 'Я заглянул под кровать и нашёл там монетку. Наверное, её случайно выронил доктор во время последнего посещения. Надо будет вернуть при встрече.';
				s.isFirst = false;
			else
				p 'Я заглянул под кровать и нашёл там ещё одну монетку.';
			end;
			take(coin);
		else
			p 'Я заглянул под кровать, но ничего там не нашёл.';
		end;
	end;
	dsc = 'К стене прикручена {железная кровать}.';
};

smallWindow = obj {
	nam = 'маленькое окошко';
	act = function(s)
		if chair.dest ~= 'окно' then
			p 'Окошко расположено слишком высоко. Туда не добраться.';
		else
			p 'Маленькое окошко, закрытое решёткой.';
			enable( shardBrick );
		end;
	end;
	used = function (s, w)
		if w == chair then
			p 'Я поставил стул около окна.';
			chair.dest = 'окно';
			drop( chair );
		end;
	end;
	dsc = 'Света, с трудом проникающего через {маленькое окошко}, едва хватает, чтобы хоть немного разогнать темноту.';
};

smallDoor = obj {
	nam = 'небольшая дверка';
	var {
		status = false;		-- Дверка открыта/закрыта. true/false.
	};
	act = function(s)
		-- Если дверка открыта - залезаем туда.
		if s.status then
			walk('inSmallDoor');
		end;
		-- Если дверка закрыта и видение 1 не показывалось - показываем видение 1.
		if not s.status and not showVision1.status then
			walk('showVision1');
		end;
		-- Если дверка закрыта и видение 1 показывалось - выводим сообщение.
		if not s.status and showVision1.status then
			p 'Дверка не открывалась. Хотя никакого замка или запора не было видно.';
		end;
	end;
	used = function (s, w)
		if w == shardBrick then
			p 'Используя осколок кирпича как рычаг, после некоторых усилий, мне удалось открыть дверку. Однако, кирпич при этом раскололся окончательно.';
			remove( shardBrick, me() );
			s.status = true;
		end;
	end;
	dsc = function(s)
		p 'На одной из стен почти на уровне пола виднеется {небольшая дверка}.';
		if s.status then
			p 'Она открыта.';
		end;
	end;
}: disable();

clawHammer = obj {
	nam = 'молоток';
	inv = 'Небольшой, но качественный молоток.';
	tak = 'Я взял молоток.';
	dsc = 'На полу лежит {молоток}.';
};

coin = obj {
	nam = 'монетка';
	inv = 'Монетка непонятного достоинства. В этом полумраке не разобрать.';
};

chair = obj {
	nam = 'стул';
	var {
		dest = 'кровать';	-- Расположение стула: "кровать", "дверь" или "окно".
	};
	dsc = function(s)
		if s.dest == 'кровать' then
			p 'У кровати стоит {стул}.';
		elseif s.dest == 'дверь' then
			p 'Около двери стоит {стул}.';
		else -- иначе стул под окном.
			p 'Под окном стоит {стул}.';
		end;
	end;
	used = function (s, w)
		if w == clawHammer then
			p 'Я сломал стул молотком.';
			disable( chair );
			enable( chairRuins );
		end;
	end;
	tak = 'Я взял стул.';
	inv = 'Простой деревянный стул.';
}: disable();

chairRuins = obj {
	nam = 'обломки стула';
	act = function()
		p 'Я порылся в обломках и взял ножку от стула.';
		disable( chairRuins );
		take( legOfChair );
	end;
	dsc = 'На полу лежат {обломки стула}.';
}: disable();

legOfChair = obj {
	nam = 'ножка от стула';
	inv = 'Всё, что осталось от стула.';
};

keys = obj {
	nam = 'связка ключей';
	var {
		dest = 'на гвозде';		-- Расположение связки ключей: "на гвозде" или "на полу".
	};
	inv = 'На связке несколько ключей. И, кажется, они все одинаковые.';
	dsc = function(s)
		if s.dest == 'на гвозде' then
			p 'На стене на гвозде висит {связка ключей}.';
		else
			p 'На полу лежит {связка ключей}.';
		end;
	end;
	act = 'Я не могу дотянуться. Слишком далеко.';
	used = function (s, w)
		if w == legOfChair then
			if s.dest == 'на гвозде' then
				p 'Я попытался ножкой от стула снять связку ключей с гвоздя. Мне почти удалось это сделать, но, вдруг, ключи выскользнули и упали на пол.';
				s.dest = 'на полу';
			elseif not have ( keys ) then
				p 'Ножкой от стула я подтянул ключи поближе. А после -- взял их рукой.';
				take( keys );
			end;
		end;
	end;
};

roomDoor2 = obj {
	nam = 'Дверь';
	var {
		status = false;			-- Дверь открыта/закрыта. true/false.
	};
	used = function (s, w)
		if w == keys then
			if s.status then
				p 'Дверь уже открыта.';
			else
				p 'Я вставил один из ключей в замок и открыл дверь.';
				s.status = true;
			end;
		end;
	end;
	dsc = function(s)
		if s.status then
			p '{Дверь} соседней палаты открыта.';
		else
			p '{Дверь} соседней палаты закрыта.';
		end;
	end;
};

roomDoor = obj {
	nam = 'дверь';
	var {
		status = false;			-- Дверь открыта/закрыта. true/false.
	};
	act = function(s)
		if s.status then
			p 'Дверь открыта.';
		else
			p 'Дверь закрыта.';
		end;
	end;
	used = function (s, w)
		if w == chair then
			p 'Я поставил стул около двери.';
			chair.dest = 'дверь';
			drop( chair );
		end;
		if w == keys then
			if s.status then
				p 'Дверь уже открыта.';
			else
				p 'Я вставил один из ключей в замок и открыл дверь.';
				s.status = true;
			end;
		end;
	end;
	dsc = 'Единственный выход из палаты закрывает массивная {дверь}.';
};

shardBrick = obj {
	nam = 'осколок кирпича';
	act = function()
		p 'Я встал на стул и с трудом дотянулся до осколка кирпича. Стул подо мной немного хрустнул.';
		take(shardBrick);
	end;
	dsc = 'На окошке лежит {осколок кирпича}.';
}: disable();

mouseBox = obj {
	nam = 'клетка с белыми мышами';
	act = 'Я заглянул в клетку и ужаснулся! Там были обычные белые мыши, но с ЧЕЛОВЕЧЕСКИМИ лицами! Они смотрели на меня каким-то жалобно-умоляющим взглядом, как будто просить помочь.';
	dsc = 'На одном столе стоит {клетка с белыми мышами}.';
	used = function (s, w)
		if w == keyOnCircuit then
			walk( 'showVision7' );
		end;
	end;
};

board = obj {
	nam = 'игровая доска';
	act = function()
		if have( dips ) then
			walk( 'playGameDlg' );
		else
			p 'Доска для неизвестной игры.';
		end;
	end;
	dsc = 'Перед ним лежит {игровая доска}.';
};

dips = obj {
	nam = 'фишки';
	tak = 'Я взял фишки.';
	inv = 'Фишки с какими-то символами.';
	dsc = 'На кровати разбросаны {фишки}.';
};

picture = obj {
	nam = 'рисунок';
	act = 'На стене нарисованы четыре символа "+".';
	dsc = 'На стене над кроватью есть {рисунок}.';
};